Index: /palm/trunk/EXAMPLES/test_salsa/test_salsa_p3d
===================================================================
--- /palm/trunk/EXAMPLES/test_salsa/test_salsa_p3d	(revision 3863)
+++ /palm/trunk/EXAMPLES/test_salsa/test_salsa_p3d	(revision 3864)
@@ -10,5 +10,5 @@
     nx                   = 19,
     ny                   = 19,
-    nz                   = 22,
+    nz                   = 60,
 
     dx                   = 2.0,
@@ -43,5 +43,5 @@
     
     day_of_year_init     =  65,          ! March 06, to avoid extreme temperatures
-    time_utc_init        = 0.0,
+    time_utc_init        = 71700.0,      !(19:55, UTC in seconds)
 
 !
@@ -100,6 +100,5 @@
                             '#v',  'v*2',  'wv',  'w*v*',  'w"v"',
                             'w',   'w*2',
-                            '#pt', 'pt*2', 'wpt', 'w*pt*', 'w"pt"',
-                            'e', 'e*', '#km', '#l',
+
 !
 !-- 2D/3D output settings
@@ -115,6 +114,5 @@
                   's_SO4', 's_OC', 's_BC', 's_NH', 's_NO',
                   'g_H2SO4','g_HNO3','g_NH3','g_OCNV','g_OCSV',
-                  'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 
-                  'N_bin6', 'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10',
+                  'N_bin3', 'm_bin4', 
 
  / ! end of d3par namelist
@@ -150,7 +148,7 @@
 !
 !-- If isdtyp = 0, define the initial aerosol size distribution by dpg, sigmag and n_lognorm
- !   dpg       = 0.01347865, 0.05400739, 0.86411863, ! mean diameter per mode (micrometres)
- !   sigmag    =        1.8,       2.16,       2.21, ! standard deviation per mode 
- !   n_lognorm =     1434.0,      445.9,      0.07,  ! number concentration per mode (#/cm3)
+ !   dpg       = 13.5E-9, 54.0E-9, 864.1E-9, ! mean diameter per mode (in metres)
+ !   sigmag    =     1.8,    2.16,     2.21, ! standard deviation per mode 
+ !   n_lognorm =  1.43E9,  4.45E8,    7.0E4, ! number concentration per mode (#/m3)
 
 !
@@ -176,6 +174,6 @@
 !
 !-- Sectional presentation of the particle size distribution
-    reglim = 3.0E-9, 5.0E-8, 2.5E-6, ! limits of the subranges (m)
-    nbin   = 3, 7,                   ! number of bins per subrange 
+    reglim = 3.0E-9, 1.0E-8, 2.5E-6, ! limits of the subranges (m)
+    nbin   = 1, 7,                   ! number of bins per subrange 
 !-- NOTE! Subrange 1 consists only of H2SO4 and/or OC
     nf2a   = 1.0,	             ! Number fraction allocated to subrange 2a (b-bins will get 1-nf2a) 
@@ -183,6 +181,15 @@
 !
 !-- Aerosol emissions:
-    salsa_source_mode = 'read_from_file', 
-!-- NOTE! chemical components of the source have to be activated in 'listspec'
+    salsa_emission_mode = 'read_from_file', ! 'no_emission','uniform' or 'read_from_file'
+
+!-- If salsa_source_mode = 'uniform', set emissions based on the variables below:
+ !   aerosol_flux_dpg     = 8.0E-9, 60.0E-9, 1000.0E-9,  ! mean diameter per mode (metres)
+ !   aerosol_flux_sigmag  =    1.8,    2.16,      2.21,  ! standard deviation per mode 
+ !   surface_aerosol_flux = 1.0E8,  1.0E9,       1.0E5,  ! number concentration per mode (#/m3)
+ !   aerosol_flux_mass_fracs_a = 0.3, 0.0, 0.6, 0.0, 0.0, 0.0, 0.0,  ! order: listspec
+ !   aerosol_flux_mass_fracs_b = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  ! order: listspec
+
+!-- NOTE! chemical components of the source have to be activated in 'listspec' 
+!--       and have to be in the same order
 
 !
@@ -201,17 +208,20 @@
 !
 !-- Switches for aerosol processes:
-    nldistupdate = .T.,
+    nldistupdate = .T., ! update aerosol size distribution
     nldepo       = .T., ! Deposition master switch
-    nldepo_vege  = .T., ! Deposition on vegetation
-    nldepo_topo  = .T., ! Deposition on walls
-    nlcnd        = .T., ! Condensation master switch
-    nlcndgas     = .T., ! Condensation of precursor gases
+    nldepo_pcm   = .T., ! Deposition on vegetation
+    nldepo_surf  = .T., ! Deposition on walls
+    nlcnd        = .F., ! Condensation master switch
+    nlcndgas     = .F., ! Condensation of precursor gases
     nlcndh2oae   = .F., ! Condensation of H2O on aerosols                          
-    nlcoag       = .T., ! Coagulation master switch
-    nsnucl       =  1,  ! Nucleation scheme (0 = off)
+    nlcoag       = .F., ! Coagulation master switch
+    nsnucl       =  0,  ! Nucleation scheme (0 = off)
     nj3          =  1,  ! J3 parametrization for nucleation 
-
-    depo_vege_type = 'zhang2001',
-    depo_topo_type = 'zhang2001',
+!
+!-- Deposition on vegetation (pcm = plant canopy model)
+    depo_pcm_par = 'zhang2001',  ! or 'petroff2010'
+!
+!-- Deposition on on ground, walls and roofs
+    depo_surf_par = 'zhang2001', ! or 'petroff2010'
 
 !
@@ -219,4 +229,5 @@
     advect_particle_water   = .T.,   ! particle water: advect or calculate at each dt_salsa 
     feedback_to_palm        = .F.,   ! feedback to flow due to condensation of water
+    nest_salsa              = .F.,   ! apply nesting for salsa
     read_restart_data_salsa = .F.,   ! skip reading restart data even if it's done for the flow
     write_binary_salsa      = .F.,   ! skip writing restart data even if it's done for the flow
Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 3863)
+++ /palm/trunk/SOURCE/Makefile	(revision 3864)
@@ -1581,5 +1581,6 @@
 	advec_s_pw.o \
 	advec_s_up.o \
-        chemistry_model_mod.o \
+	chem_gasphase_mod.o \
+	chemistry_model_mod.o \
 	diffusion_s.o \
 	netcdf_data_input_mod.o \
Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3863)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3864)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Remove tailing white spaces
+! 
+! 3696 2019-01-24 16:37:35Z suehring
 ! Bugfix in degradation height
 ! 
@@ -349,6 +352,6 @@
 
        USE salsa_util_mod,                                                     &
-           ONLY:  sums_salsa_ws_l   
-       
+           ONLY:  sums_salsa_ws_l
+
        USE statistics,                                                         &
            ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsncs_ws_l,& 
@@ -357,5 +360,5 @@
                   sums_wssas_ws_l,  sums_wsss_ws_l, sums_wsus_ws_l,            &
                   sums_wsvs_ws_l
-  
+
 
 !
@@ -418,8 +421,8 @@
              sums_wssas_ws_l = 0.0_wp
           ENDIF        
-          
+
           IF ( salsa )  THEN
              ALLOCATE( sums_salsa_ws_l(nzb:nzt+1,0:threads_per_task-1) )
-             sums_salsa_ws_l = 0.0_wp   
+             sums_salsa_ws_l = 0.0_wp
           ENDIF
 
@@ -1143,6 +1146,6 @@
 
        USE salsa_util_mod,                                                     &
-           ONLY:  sums_salsa_ws_l            
-           
+           ONLY:  sums_salsa_ws_l
+
        USE statistics,                                                         &
            ONLY:  sums_us2_ws_l, sums_vs2_ws_l, sums_ws2_ws_l, sums_wsncs_ws_l,&
@@ -1221,5 +1224,5 @@
 
        USE salsa_util_mod,                                                     &
-           ONLY:  sums_salsa_ws_l   
+           ONLY:  sums_salsa_ws_l
 
        USE statistics,                                                         &
@@ -1824,7 +1827,7 @@
                     ) * weight_substep(intermediate_timestep_count)
              ENDDO
-             
+
           CASE ( 's' )
-          
+
              DO  k = nzb, nzt
                 sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn) +                 &
@@ -1835,7 +1838,7 @@
                     ) * weight_substep(intermediate_timestep_count)
              ENDDO
-                  
+
          CASE ( 'aerosol_mass', 'aerosol_number', 'salsa_gas' )
-         
+
              DO  k = nzb, nzt
                 sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn) +               &
@@ -1845,5 +1848,5 @@
                                 *   ABS( w(k,j,i) - hom(k,1,3,0)            )  &
                     ) * weight_substep(intermediate_timestep_count)
-             ENDDO             
+             ENDDO
 
 !          CASE ( 'kc' )
@@ -1852,5 +1855,5 @@
 
          END SELECT
-         
+
     END SUBROUTINE advec_s_ws_ij
 
@@ -3595,15 +3598,15 @@
            ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_max,    &
                   nzt, advc_flags_1
-           
+
        USE kinds
-       
+
        USE salsa_util_mod,                                                     &
-           ONLY:  sums_salsa_ws_l      
-       
+           ONLY:  sums_salsa_ws_l
+
        USE statistics,                                                         &
            ONLY:  hom, sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,       &
                   sums_wsqcs_ws_l, sums_wsqrs_ws_l, sums_wsncs_ws_l,           &
                   sums_wsnrs_ws_l, sums_wsss_ws_l, weight_substep  
-                  
+
 
 
Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 3863)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 3864)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Add a call for salsa_prognostic_equations
+! 
+! 3840 2019-03-29 10:35:52Z knoop
 ! bugfix: intent of dummy arguments changed to inout
 ! 
@@ -280,4 +283,5 @@
                salsa_init,                                                     &
                salsa_header,                                                   &
+               salsa_prognostic_equations,                                     &
                salsa_swap_timelevel,                                           &
                salsa_3d_data_averaging,                                        &
@@ -909,4 +913,5 @@
     IF ( gust_module_enabled )  CALL gust_prognostic_equations()
     IF ( ocean_mode          )  CALL ocean_prognostic_equations()
+    IF ( salsa               )  CALL salsa_prognostic_equations()
 
 
@@ -930,4 +935,5 @@
     IF ( gust_module_enabled )  CALL gust_prognostic_equations( i, j, i_omp_start, tn )
     IF ( ocean_mode          )  CALL ocean_prognostic_equations( i, j, i_omp_start, tn )
+    IF ( salsa               )  CALL salsa_prognostic_equations( i, j, i_omp_start, tn )
 
 
Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3864)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! get_variable_4d_to_3d_real modified to enable read in data of type
+! data(t,y,x,n) one timestep at a time + some routines made public
+! 
+! 3855 2019-04-03 10:00:59Z suehring
 ! Typo removed
 ! 
@@ -913,5 +917,6 @@
            netcdf_data_input_interpolate, netcdf_data_input_offline_nesting,   &
            netcdf_data_input_surface_data, netcdf_data_input_topo,             &
-           netcdf_data_input_var, get_attribute, get_variable, open_read_file
+           netcdf_data_input_var, get_attribute, get_variable, open_read_file, &
+           check_existence, inquire_num_variables, inquire_variable_names
 
 
@@ -5557,5 +5562,5 @@
        INTEGER(iwp)                  ::  ke              !< start index of 3rd dimension
        INTEGER(iwp)                  ::  ks              !< end index of 3rd dimension
-       
+
        INTEGER(KIND=1), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp  !< temporary variable to read data from file according 
                                                                  !< to its reverse memory access
@@ -5566,5 +5571,5 @@
 !
 !--    Inquire variable id
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )   
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
 !--    Check for collective read-operation and set respective NetCDF flags if
@@ -5573,5 +5578,5 @@
 #if defined( __netcdf4_parallel )
           nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
-#endif          
+#endif
        ENDIF
 !
@@ -5582,7 +5587,7 @@
        nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
                                start = (/ is+1,    js+1,    ks+1 /),           &
-                               count = (/ ie-is+1, je-js+1, ke-ks+1 /) )                              
-
-       CALL handle_error( 'get_variable_3d_int8', 533, variable_name )                               
+                               count = (/ ie-is+1, je-js+1, ke-ks+1 /) )
+
+       CALL handle_error( 'get_variable_3d_int8', 533, variable_name )
 !
 !--    Resort data. Please note, dimension subscripts of var all start at 1. 
@@ -5594,5 +5599,5 @@
           ENDDO
        ENDDO
-       
+
        DEALLOCATE( tmp )
 
@@ -5627,5 +5632,5 @@
        INTEGER(iwp)                  ::  ke              !< start index of 3rd dimension
        INTEGER(iwp)                  ::  ks              !< end index of 3rd dimension
-       
+
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp !< temporary variable to read data from file according 
                                                          !< to its reverse memory access
@@ -5641,5 +5646,5 @@
 !--    required. 
        IF ( collective_read )  THEN
-#if defined( __netcdf4_parallel )       
+#if defined( __netcdf4_parallel )
           nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
 #endif
@@ -5653,5 +5658,5 @@
                                start = (/ is+1,    js+1,    ks+1 /),           &
                                count = (/ ie-is+1, je-js+1, ke-ks+1 /) )   
-                               
+
        CALL handle_error( 'get_variable_3d_real', 534, variable_name )
 !
@@ -5664,5 +5669,5 @@
           ENDDO
        ENDDO
-       
+
        DEALLOCATE( tmp )
 
@@ -5737,9 +5742,9 @@
        ELSE
 !
-!--    Allocate temporary variable according to memory access on file. 
-       ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e) )
-!
-!--    Get variable
-          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+!--       Allocate temporary variable according to memory access on file. 
+          ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e) )
+!
+!--       Get variable
+          nc_stat = NF90_GET_VAR( id, id_var, tmp,                             &
                                start = (/ is+1,    js+1,   k1s+1, k2s+1 /),    &
                                count = (/ ie-is+1, je-js+1,                    &
@@ -5748,5 +5753,5 @@
           CALL handle_error( 'get_variable_4d_real', 535, variable_name )
 !
-!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+!--       Resort data. Please note, dimension subscripts of var all start at 1. 
           DO  i = is, ie 
              DO  j = js, je
@@ -5758,5 +5763,5 @@
              ENDDO
           ENDDO
-       
+
           DEALLOCATE( tmp )
        ENDIF
@@ -5828,16 +5833,16 @@
        ELSE
 !
-!--    Allocate temporary variable according to memory access on file. 
+!--       Allocate temporary variable according to memory access on file. 
           ALLOCATE( tmp(is:ie,js:je,ks:ke) )
 !
-!--    Get variable
-          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
-                                  start = (/ ns+1, is+1,    js+1,    ks+1 /),           &
-                                  count = (/ 1, ie-is+1, je-js+1, ke-ks+1 /) )   
-                               
+!--       Get variable
+          nc_stat = NF90_GET_VAR( id, id_var, tmp,                             &
+                                  start = (/ is+1,    js+1,    ks+1,   ns+1 /),&
+                                  count = (/ ie-is+1, je-js+1, ke-ks+1, 1   /) )
+
           CALL handle_error( 'get_variable_4d_to_3d_real', 536, variable_name )
 !
-!--    Resort data. Please note, dimension subscripts of var all start at 1. 
-          DO  i = is, ie 
+!--       Resort data. Please note, dimension subscripts of var all start at 1.
+          DO  i = is, ie
              DO  j = js, je
                 DO  k = ks, ke
@@ -5846,5 +5851,5 @@
              ENDDO
           ENDDO
-       
+
          DEALLOCATE( tmp )
 
@@ -5962,5 +5967,7 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp)                  ::  ns              !< start index for subdomain input along n dimension: ns coincides here with ne, since, we select only one value along the 1st dimension n
+       INTEGER(iwp)                  ::  ns              !< start index for subdomain input along n dimension: 
+                                                         !< ns coincides here with ne, since, we select only one 
+                                                         !< value along the 1st dimension n
 
        INTEGER(iwp)                  ::  t               !< index along t direction
@@ -5986,8 +5993,8 @@
 !
 !--    Inquire variable id
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )  
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
 !--    Check for collective read-operation and set respective NetCDF flags if
-!--    required. 
+!--    required.
        IF ( collective_read )  THEN
           nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
@@ -6036,5 +6043,5 @@
           ENDDO 
 
-         DEALLOCATE( tmp )
+          DEALLOCATE( tmp )
 
        ENDIF
